diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/post-template.php ./wordpress-3.4/wp-includes/post-template.php
*** ./wordpress-3.3.2/wp-includes/post-template.php	2011-11-10 12:35:25.000000000 -0600
--- ./wordpress-3.4/wp-includes/post-template.php	2012-06-11 16:25:05.000000000 -0500
***************
*** 188,197 ****
  	$hasTeaser = false;
  
  	// If post password required and it doesn't match the cookie.
! 	if ( post_password_required($post) ) {
! 		$output = get_the_password_form();
! 		return $output;
! 	}
  
  	if ( $page > count($pages) ) // if the requested page doesn't exist
  		$page = count($pages); // give them the highest numbered page that DOES exist
--- 187,194 ----
  	$hasTeaser = false;
  
  	// If post password required and it doesn't match the cookie.
! 	if ( post_password_required($post) )
! 		return get_the_password_form();
  
  	if ( $page > count($pages) ) // if the requested page doesn't exist
  		$page = count($pages); // give them the highest numbered page that DOES exist
***************
*** 414,421 ****
  		$classes[] = 'archive';
  	if ( is_date() )
  		$classes[] = 'date';
! 	if ( is_search() )
  		$classes[] = 'search';
  	if ( is_paged() )
  		$classes[] = 'paged';
  	if ( is_attachment() )
--- 411,420 ----
  		$classes[] = 'archive';
  	if ( is_date() )
  		$classes[] = 'date';
! 	if ( is_search() ) {
  		$classes[] = 'search';
+ 		$classes[] = $wp_query->posts ? 'search-results' : 'search-no-results';
+ 	}
  	if ( is_paged() )
  		$classes[] = 'paged';
  	if ( is_attachment() )
***************
*** 490,504 ****
  		}
  		if ( is_page_template() ) {
  			$classes[] = 'page-template';
! 			$classes[] = 'page-template-' . sanitize_html_class( str_replace( '.', '-', get_post_meta( $page_id, '_wp_page_template', true ) ), '' );
  		} else {
  			$classes[] = 'page-template-default';
  		}
- 	} elseif ( is_search() ) {
- 		if ( !empty( $wp_query->posts ) )
- 			$classes[] = 'search-results';
- 		else
- 			$classes[] = 'search-no-results';
  	}
  
  	if ( is_user_logged_in() )
--- 489,498 ----
  		}
  		if ( is_page_template() ) {
  			$classes[] = 'page-template';
! 			$classes[] = 'page-template-' . sanitize_html_class( str_replace( '.', '-', get_page_template_slug( $page_id ) ) );
  		} else {
  			$classes[] = 'page-template-default';
  		}
  	}
  
  	if ( is_user_logged_in() )
***************
*** 507,513 ****
  	if ( is_admin_bar_showing() )
  		$classes[] = 'admin-bar';
  
! 	if ( get_background_image() || get_background_color() )
  		$classes[] = 'custom-background';
  
  	$page = $wp_query->get( 'page' );
--- 501,507 ----
  	if ( is_admin_bar_showing() )
  		$classes[] = 'admin-bar';
  
! 	if ( get_theme_mod( 'background_color' ) || get_background_image() )
  		$classes[] = 'custom-background';
  
  	$page = $wp_query->get( 'page' );
***************
*** 555,576 ****
   *
   * @since 2.7.0
   *
!  * @param int|object $post An optional post.  Global $post used if not provided.
   * @return bool false if a password is not required or the correct password cookie is present, true otherwise.
   */
  function post_password_required( $post = null ) {
  	$post = get_post($post);
  
! 	if ( empty($post->post_password) )
  		return false;
  
! 	if ( !isset($_COOKIE['wp-postpass_' . COOKIEHASH]) )
  		return true;
  
! 	if ( stripslashes( $_COOKIE['wp-postpass_' . COOKIEHASH] ) != $post->post_password )
! 		return true;
  
! 	return false;
  }
  
  /**
--- 549,577 ----
   *
   * @since 2.7.0
   *
!  * @param int|object $post An optional post. Global $post used if not provided.
   * @return bool false if a password is not required or the correct password cookie is present, true otherwise.
   */
  function post_password_required( $post = null ) {
+ 	global $wp_hasher;
+ 
  	$post = get_post($post);
  
! 	if ( empty( $post->post_password ) )
  		return false;
  
! 	if ( ! isset( $_COOKIE['wp-postpass_' . COOKIEHASH] ) )
  		return true;
  
! 	if ( empty( $wp_hasher ) ) {
! 		require_once( ABSPATH . 'wp-includes/class-phpass.php');
! 		// By default, use the portable hash from phpass
! 		$wp_hasher = new PasswordHash(8, true);
! 	}
  
! 	$hash = stripslashes( $_COOKIE[ 'wp-postpass_' . COOKIEHASH ] );
! 
! 	return ! $wp_hasher->CheckPassword( $post->post_password, $hash );
  }
  
  /**
***************
*** 994,1000 ****
  	 * @param string $output Passed by reference. Used to append additional content.
  	 * @param int $depth Depth of page. Used for padding.
  	 */
! 	function start_lvl(&$output, $depth) {
  		$indent = str_repeat("\t", $depth);
  		$output .= "\n$indent<ul class='children'>\n";
  	}
--- 995,1001 ----
  	 * @param string $output Passed by reference. Used to append additional content.
  	 * @param int $depth Depth of page. Used for padding.
  	 */
! 	function start_lvl( &$output, $depth = 0, $args = array() ) {
  		$indent = str_repeat("\t", $depth);
  		$output .= "\n$indent<ul class='children'>\n";
  	}
***************
*** 1006,1012 ****
  	 * @param string $output Passed by reference. Used to append additional content.
  	 * @param int $depth Depth of page. Used for padding.
  	 */
! 	function end_lvl(&$output, $depth) {
  		$indent = str_repeat("\t", $depth);
  		$output .= "$indent</ul>\n";
  	}
--- 1007,1013 ----
  	 * @param string $output Passed by reference. Used to append additional content.
  	 * @param int $depth Depth of page. Used for padding.
  	 */
! 	function end_lvl( &$output, $depth = 0, $args = array() ) {
  		$indent = str_repeat("\t", $depth);
  		$output .= "$indent</ul>\n";
  	}
***************
*** 1021,1027 ****
  	 * @param int $current_page Page ID.
  	 * @param array $args
  	 */
! 	function start_el(&$output, $page, $depth, $args, $current_page) {
  		if ( $depth )
  			$indent = str_repeat("\t", $depth);
  		else
--- 1022,1028 ----
  	 * @param int $current_page Page ID.
  	 * @param array $args
  	 */
! 	function start_el( &$output, $page, $depth, $args, $current_page = 0 ) {
  		if ( $depth )
  			$indent = str_repeat("\t", $depth);
  		else
***************
*** 1064,1070 ****
  	 * @param object $page Page data object. Not used.
  	 * @param int $depth Depth of page. Not Used.
  	 */
! 	function end_el(&$output, $page, $depth) {
  		$output .= "</li>\n";
  	}
  
--- 1065,1071 ----
  	 * @param object $page Page data object. Not used.
  	 * @param int $depth Depth of page. Not Used.
  	 */
! 	function end_el( &$output, $page, $depth = 0, $args = array() ) {
  		$output .= "</li>\n";
  	}
  
***************
*** 1102,1108 ****
  	 * @param int $depth Depth of page in reference to parent pages. Used for padding.
  	 * @param array $args Uses 'selected' argument for selected page to set selected HTML attribute for option element.
  	 */
! 	function start_el(&$output, $page, $depth, $args) {
  		$pad = str_repeat('&nbsp;', $depth * 3);
  
  		$output .= "\t<option class=\"level-$depth\" value=\"$page->ID\"";
--- 1103,1109 ----
  	 * @param int $depth Depth of page in reference to parent pages. Used for padding.
  	 * @param array $args Uses 'selected' argument for selected page to set selected HTML attribute for option element.
  	 */
! 	function start_el(&$output, $page, $depth, $args, $id = 0) {
  		$pad = str_repeat('&nbsp;', $depth * 3);
  
  		$output .= "\t<option class=\"level-$depth\" value=\"$page->ID\"";
***************
*** 1165,1171 ****
  	$post_title = esc_attr( $_post->post_title );
  
  	if ( $text )
! 		$link_text = esc_attr( $text );
  	elseif ( $size && 'none' != $size )
  		$link_text = wp_get_attachment_image( $id, $size, $icon );
  	else
--- 1166,1172 ----
  	$post_title = esc_attr( $_post->post_title );
  
  	if ( $text )
! 		$link_text = $text;
  	elseif ( $size && 'none' != $size )
  		$link_text = wp_get_attachment_image( $id, $size, $icon );
  	else
***************
*** 1215,1222 ****
   */
  function get_the_password_form() {
  	global $post;
! 	$label = 'pwbox-'.(empty($post->ID) ? rand() : $post->ID);
! 	$output = '<form action="' . get_option('siteurl') . '/wp-pass.php" method="post">
  	<p>' . __("This post is password protected. To view it please enter your password below:") . '</p>
  	<p><label for="' . $label . '">' . __("Password:") . ' <input name="post_password" id="' . $label . '" type="password" size="20" /></label> <input type="submit" name="Submit" value="' . esc_attr__("Submit") . '" /></p>
  	</form>
--- 1216,1223 ----
   */
  function get_the_password_form() {
  	global $post;
! 	$label = 'pwbox-' . ( empty($post->ID) ? rand() : $post->ID );
! 	$output = '<form action="' . esc_url( site_url( 'wp-login.php?action=postpass', 'login_post' ) ) . '" method="post">
  	<p>' . __("This post is password protected. To view it please enter your password below:") . '</p>
  	<p><label for="' . $label . '">' . __("Password:") . ' <input name="post_password" id="' . $label . '" type="password" size="20" /></label> <input type="submit" name="Submit" value="' . esc_attr__("Submit") . '" /></p>
  	</form>
***************
*** 1237,1266 ****
   * @param string $template The specific template name if specific matching is required.
   * @return bool False on failure, true if success.
   */
! function is_page_template($template = '') {
! 	if (!is_page()) {
  		return false;
- 	}
  
! 	global $wp_query;
  
! 	$page = $wp_query->get_queried_object();
! 	$custom_fields = get_post_custom_values('_wp_page_template',$page->ID);
! 	$page_template = $custom_fields[0];
! 
! 	// We have no argument passed so just see if a page_template has been specified
! 	if ( empty( $template ) ) {
! 		if ( !empty( $page_template ) and ( 'default' != $page_template ) ) {
! 			return true;
! 		}
! 	} elseif ( $template == $page_template) {
  		return true;
- 	}
  
  	return false;
  }
  
  /**
   * Retrieve formatted date timestamp of a revision (linked to that revisions's page).
   *
   * @package WordPress
--- 1238,1281 ----
   * @param string $template The specific template name if specific matching is required.
   * @return bool False on failure, true if success.
   */
! function is_page_template( $template = '' ) {
! 	if ( ! is_page() )
  		return false;
  
! 	$page_template = get_page_template_slug( get_queried_object_id() );
  
! 	if ( empty( $template ) )
! 		return (bool) $page_template;
! 
! 	if ( $template == $page_template )
! 		return true;
! 
! 	if ( 'default' == $template && ! $page_template )
  		return true;
  
  	return false;
  }
  
  /**
+  * Get the specific template name for a page.
+  *
+  * @since 3.4.0
+  *
+  * @param int $id The page ID to check. Defaults to the current post, when used in the loop.
+  * @return string|bool Page template filename. Returns an empty string when the default page template
+  * 	is in use. Returns false if the post is not a page.
+  */
+ function get_page_template_slug( $post_id = null ) {
+ 	$post = get_post( $post_id );
+ 	if ( 'page' != $post->post_type )
+ 		return false;
+ 	$template = get_post_meta( $post->ID, '_wp_page_template', true );
+ 	if ( ! $template || 'default' == $template )
+ 		return '';
+ 	return $template;
+ }
+ 
+ /**
   * Retrieve formatted date timestamp of a revision (linked to that revisions's page).
   *
   * @package WordPress
***************
*** 1307,1313 ****
   *
   * Second argument controls parameters:
   *   (bool)   parent : include the parent (the "Current Revision") in the list.
!  *   (string) format : 'list' or 'form-table'.  'list' outputs UL, 'form-table'
   *                     outputs TABLE with UI.
   *   (int)    right  : what revision is currently being viewed - used in
   *                     form-table format.
--- 1322,1328 ----
   *
   * Second argument controls parameters:
   *   (bool)   parent : include the parent (the "Current Revision") in the list.
!  *   (string) format : 'list' or 'form-table'. 'list' outputs UL, 'form-table'
   *                     outputs TABLE with UI.
   *   (int)    right  : what revision is currently being viewed - used in
   *                     form-table format.
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/post-thumbnail-template.php ./wordpress-3.4/wp-includes/post-thumbnail-template.php
*** ./wordpress-3.3.2/wp-includes/post-thumbnail-template.php	2011-10-20 10:11:49.000000000 -0500
--- ./wordpress-3.4/wp-includes/post-thumbnail-template.php	2012-04-30 10:55:57.000000000 -0500
***************
*** 39,45 ****
   *
   * @since 2.9.0
   *
!  * @param int $size Optional. Image size.  Defaults to 'post-thumbnail', which theme sets using set_post_thumbnail_size( $width, $height, $crop_flag );.
   * @param string|array $attr Optional. Query string or array of attributes.
   */
  function the_post_thumbnail( $size = 'post-thumbnail', $attr = '' ) {
--- 39,45 ----
   *
   * @since 2.9.0
   *
!  * @param int $size Optional. Image size. Defaults to 'post-thumbnail', which theme sets using set_post_thumbnail_size( $width, $height, $crop_flag );.
   * @param string|array $attr Optional. Query string or array of attributes.
   */
  function the_post_thumbnail( $size = 'post-thumbnail', $attr = '' ) {
***************
*** 50,58 ****
   * Update cache for thumbnails in the current loop
   *
   * @since 3.2
   */
! function update_post_thumbnail_cache() {
! 	global $wp_query;
  
  	if ( $wp_query->thumbnails_cached )
  		return;
--- 50,61 ----
   * Update cache for thumbnails in the current loop
   *
   * @since 3.2
+  *
+  * @param object $wp_query Optional. A WP_Query instance. Defaults to the $wp_query global.
   */
! function update_post_thumbnail_cache( $wp_query = null ) {
! 	if ( ! $wp_query )
! 		$wp_query = $GLOBALS['wp_query'];
  
  	if ( $wp_query->thumbnails_cached )
  		return;
***************
*** 64,76 ****
  	}
  
  	if ( ! empty ( $thumb_ids ) ) {
! 		get_posts( array(
! 				'update_post_term_cache' => false,
! 				'include' => $thumb_ids,
! 				'post_type' => 'attachment',
! 				'post_status' => 'inherit',
! 				'nopaging' => true
! 		) );
  	}
  
  	$wp_query->thumbnails_cached = true;
--- 67,73 ----
  	}
  
  	if ( ! empty ( $thumb_ids ) ) {
! 		_prime_post_caches( $thumb_ids, false, true );
  	}
  
  	$wp_query->thumbnails_cached = true;
***************
*** 82,88 ****
   * @since 2.9.0
   *
   * @param int $post_id Optional. Post ID.
!  * @param string $size Optional. Image size.  Defaults to 'thumbnail'.
   * @param string|array $attr Optional. Query string or array of attributes.
   */
  function get_the_post_thumbnail( $post_id = null, $size = 'post-thumbnail', $attr = '' ) {
--- 79,85 ----
   * @since 2.9.0
   *
   * @param int $post_id Optional. Post ID.
!  * @param string $size Optional. Image size. Defaults to 'post-thumbnail'.
   * @param string|array $attr Optional. Query string or array of attributes.
   */
  function get_the_post_thumbnail( $post_id = null, $size = 'post-thumbnail', $attr = '' ) {
***************
*** 100,104 ****
  	}
  	return apply_filters( 'post_thumbnail_html', $html, $post_id, $post_thumbnail_id, $size, $attr );
  }
- 
- ?>
--- 97,99 ----
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/query.php ./wordpress-3.4/wp-includes/query.php
*** ./wordpress-3.3.2/wp-includes/query.php	2011-11-23 18:20:21.000000000 -0600
--- ./wordpress-3.4/wp-includes/query.php	2012-06-12 18:09:27.000000000 -0500
***************
*** 27,35 ****
  	return $wp_query->get($var);
  }
  
- 
  /**
!  * Retrieve the currently-queried object.  Wrapper for $wp_query->get_queried_object()
   *
   * @uses WP_Query::get_queried_object
   *
--- 27,34 ----
  	return $wp_query->get($var);
  }
  
  /**
!  * Retrieve the currently-queried object. Wrapper for $wp_query->get_queried_object()
   *
   * @uses WP_Query::get_queried_object
   *
***************
*** 728,734 ****
  }
  
  /*
!  * The Loop.  Post loop control.
   */
  
  /**
--- 727,733 ----
  }
  
  /*
!  * The Loop. Post loop control.
   */
  
  /**
***************
*** 1261,1267 ****
  	var $query_vars_hash = false;
  
  	/**
! 	 * Whether query vars have changed since the initial parse_query() call.  Used to catch modifications to query vars made
  	 * via pre_get_posts hooks.
  	 *
  	 * @since 3.1.1
--- 1260,1266 ----
  	var $query_vars_hash = false;
  
  	/**
! 	 * Whether query vars have changed since the initial parse_query() call. Used to catch modifications to query vars made
  	 * via pre_get_posts hooks.
  	 *
  	 * @since 3.1.1
***************
*** 1454,1460 ****
  		if ( '' !== $qv['minute'] ) $qv['minute'] = absint($qv['minute']);
  		if ( '' !== $qv['second'] ) $qv['second'] = absint($qv['second']);
  
! 		// Compat.  Map subpost to attachment.
  		if ( '' != $qv['subpost'] )
  			$qv['attachment'] = $qv['subpost'];
  		if ( '' != $qv['subpost_id'] )
--- 1453,1459 ----
  		if ( '' !== $qv['minute'] ) $qv['minute'] = absint($qv['minute']);
  		if ( '' !== $qv['second'] ) $qv['second'] = absint($qv['second']);
  
! 		// Compat. Map subpost to attachment.
  		if ( '' != $qv['subpost'] )
  			$qv['attachment'] = $qv['subpost'];
  		if ( '' != $qv['subpost_id'] )
***************
*** 1477,1483 ****
  			$this->is_page = true;
  			$this->is_single = false;
  		} else {
! 		// Look for archive queries.  Dates, categories, authors, search, post type archives.
  
  			if ( !empty($qv['s']) ) {
  				$this->is_search = true;
--- 1476,1482 ----
  			$this->is_page = true;
  			$this->is_single = false;
  		} else {
! 		// Look for archive queries. Dates, categories, authors, search, post type archives.
  
  			if ( !empty($qv['s']) ) {
  				$this->is_search = true;
***************
*** 1625,1631 ****
  		}
  
  		if ( '' != $qv['pagename'] ) {
! 			$this->queried_object =& get_page_by_path($qv['pagename']);
  			if ( !empty($this->queried_object) )
  				$this->queried_object_id = (int) $this->queried_object->ID;
  			else
--- 1624,1630 ----
  		}
  
  		if ( '' != $qv['pagename'] ) {
! 			$this->queried_object = get_page_by_path($qv['pagename']);
  			if ( !empty($this->queried_object) )
  				$this->queried_object_id = (int) $this->queried_object->ID;
  			else
***************
*** 2181,2187 ****
  			if ( !empty($q['sentence']) ) {
  				$q['search_terms'] = array($q['s']);
  			} else {
! 				preg_match_all('/".*?("|$)|((?<=[\\s",+])|^)[^\\s",+]+/', $q['s'], $matches);
  				$q['search_terms'] = array_map('_search_terms_tidy', $matches[0]);
  			}
  			$n = !empty($q['exact']) ? '' : '%';
--- 2180,2186 ----
  			if ( !empty($q['sentence']) ) {
  				$q['search_terms'] = array($q['s']);
  			} else {
! 				preg_match_all('/".*?("|$)|((?<=[\r\n\t ",+])|^)[^\r\n\t ",+]+/', $q['s'], $matches);
  				$q['search_terms'] = array_map('_search_terms_tidy', $matches[0]);
  			}
  			$n = !empty($q['exact']) ? '' : '%';
***************
*** 2312,2321 ****
  
  		// MIME-Type stuff for attachment browsing
  
! 		if ( isset($q['post_mime_type']) && '' != $q['post_mime_type'] ) {
! 			$table_alias = $post_status_join ? $wpdb->posts : '';
! 			$whichmimetype = wp_post_mime_type_where($q['post_mime_type'], $table_alias);
! 		}
  
  		$where .= $search . $whichauthor . $whichmimetype;
  
--- 2311,2318 ----
  
  		// MIME-Type stuff for attachment browsing
  
! 		if ( isset( $q['post_mime_type'] ) && '' != $q['post_mime_type'] )
! 			$whichmimetype = wp_post_mime_type_where( $q['post_mime_type'], $wpdb->posts );
  
  		$where .= $search . $whichauthor . $whichmimetype;
  
***************
*** 2346,2351 ****
--- 2343,2349 ----
  
  				switch ( $orderby ) {
  					case 'menu_order':
+ 						$orderby = "$wpdb->posts.menu_order";
  						break;
  					case 'ID':
  						$orderby = "$wpdb->posts.ID";
***************
*** 2449,2461 ****
  			}
  			if ( !empty($r_status) ) {
  				if ( !empty($q['perm'] ) && 'editable' == $q['perm'] && !current_user_can($edit_others_cap) )
! 					$statuswheres[] = "($wpdb->posts.post_author = $user_ID " .  "AND (" . join( ' OR ', $r_status ) . "))";
  				else
  					$statuswheres[] = "(" . join( ' OR ', $r_status ) . ")";
  			}
  			if ( !empty($p_status) ) {
  				if ( !empty($q['perm'] ) && 'readable' == $q['perm'] && !current_user_can($read_private_cap) )
! 					$statuswheres[] = "($wpdb->posts.post_author = $user_ID " .  "AND (" . join( ' OR ', $p_status ) . "))";
  				else
  					$statuswheres[] = "(" . join( ' OR ', $p_status ) . ")";
  			}
--- 2447,2459 ----
  			}
  			if ( !empty($r_status) ) {
  				if ( !empty($q['perm'] ) && 'editable' == $q['perm'] && !current_user_can($edit_others_cap) )
! 					$statuswheres[] = "($wpdb->posts.post_author = $user_ID " . "AND (" . join( ' OR ', $r_status ) . "))";
  				else
  					$statuswheres[] = "(" . join( ' OR ', $r_status ) . ")";
  			}
  			if ( !empty($p_status) ) {
  				if ( !empty($q['perm'] ) && 'readable' == $q['perm'] && !current_user_can($read_private_cap) )
! 					$statuswheres[] = "($wpdb->posts.post_author = $user_ID " . "AND (" . join( ' OR ', $p_status ) . "))";
  				else
  					$statuswheres[] = "(" . join( ' OR ', $p_status ) . ")";
  			}
***************
*** 2477,2483 ****
  				$where .= " OR $wpdb->posts.post_status = '$state'";
  			}
  
! 			if ( is_admin() ) {
  				// Add protected states that should show in the admin all list.
  				$admin_all_states = get_post_stati( array('protected' => true, 'show_in_admin_all_list' => true) );
  				foreach ( (array) $admin_all_states as $state )
--- 2475,2481 ----
  				$where .= " OR $wpdb->posts.post_status = '$state'";
  			}
  
! 			if ( $this->is_admin ) {
  				// Add protected states that should show in the admin all list.
  				$admin_all_states = get_post_stati( array('protected' => true, 'show_in_admin_all_list' => true) );
  				foreach ( (array) $admin_all_states as $state )
***************
*** 2510,2527 ****
  		// Paging
  		if ( empty($q['nopaging']) && !$this->is_singular ) {
  			$page = absint($q['paged']);
! 			if ( empty($page) )
  				$page = 1;
  
  			if ( empty($q['offset']) ) {
- 				$pgstrt = '';
  				$pgstrt = ($page - 1) * $q['posts_per_page'] . ', ';
- 				$limits = 'LIMIT ' . $pgstrt . $q['posts_per_page'];
  			} else { // we're ignoring $page and using 'offset'
  				$q['offset'] = absint($q['offset']);
  				$pgstrt = $q['offset'] . ', ';
- 				$limits = 'LIMIT ' . $pgstrt . $q['posts_per_page'];
  			}
  		}
  
  		// Comments feeds
--- 2508,2523 ----
  		// Paging
  		if ( empty($q['nopaging']) && !$this->is_singular ) {
  			$page = absint($q['paged']);
! 			if ( !$page )
  				$page = 1;
  
  			if ( empty($q['offset']) ) {
  				$pgstrt = ($page - 1) * $q['posts_per_page'] . ', ';
  			} else { // we're ignoring $page and using 'offset'
  				$q['offset'] = absint($q['offset']);
  				$pgstrt = $q['offset'] . ', ';
  			}
+ 			$limits = 'LIMIT ' . $pgstrt . $q['posts_per_page'];
  		}
  
  		// Comments feeds
***************
*** 2564,2570 ****
  
  		$pieces = array( 'where', 'groupby', 'join', 'orderby', 'distinct', 'fields', 'limits' );
  
! 		// Apply post-paging filters on where and join.  Only plugins that
  		// manipulate paging queries should use these hooks.
  		if ( !$q['suppress_filters'] ) {
  			$where		= apply_filters_ref_array( 'posts_where_paged',	array( $where, &$this ) );
--- 2560,2566 ----
  
  		$pieces = array( 'where', 'groupby', 'join', 'orderby', 'distinct', 'fields', 'limits' );
  
! 		// Apply post-paging filters on where and join. Only plugins that
  		// manipulate paging queries should use these hooks.
  		if ( !$q['suppress_filters'] ) {
  			$where		= apply_filters_ref_array( 'posts_where_paged',	array( $where, &$this ) );
***************
*** 2581,2590 ****
  				$$piece = isset( $clauses[ $piece ] ) ? $clauses[ $piece ] : '';
  		}
  
! 		// Announce current selection parameters.  For use by caching plugins.
  		do_action( 'posts_selection', $where . $groupby . $orderby . $limits . $join );
  
! 		// Filter again for the benefit of caching plugins.  Regular plugins should use the hooks above.
  		if ( !$q['suppress_filters'] ) {
  			$where		= apply_filters_ref_array( 'posts_where_request',		array( $where, &$this ) );
  			$groupby	= apply_filters_ref_array( 'posts_groupby_request',		array( $groupby, &$this ) );
--- 2577,2586 ----
  				$$piece = isset( $clauses[ $piece ] ) ? $clauses[ $piece ] : '';
  		}
  
! 		// Announce current selection parameters. For use by caching plugins.
  		do_action( 'posts_selection', $where . $groupby . $orderby . $limits . $join );
  
! 		// Filter again for the benefit of caching plugins. Regular plugins should use the hooks above.
  		if ( !$q['suppress_filters'] ) {
  			$where		= apply_filters_ref_array( 'posts_where_request',		array( $where, &$this ) );
  			$groupby	= apply_filters_ref_array( 'posts_groupby_request',		array( $groupby, &$this ) );
***************
*** 2609,2617 ****
  		if ( !$q['no_found_rows'] && !empty($limits) )
  			$found_rows = 'SQL_CALC_FOUND_ROWS';
  
! 		$this->request = " SELECT $found_rows $distinct $fields FROM $wpdb->posts $join WHERE 1=1 $where $groupby $orderby $limits";
! 		if ( !$q['suppress_filters'] )
! 			$this->request = apply_filters_ref_array('posts_request', array( $this->request, &$this ) );
  
  		if ( 'ids' == $q['fields'] ) {
  			$this->posts = $wpdb->get_col($this->request);
--- 2605,2615 ----
  		if ( !$q['no_found_rows'] && !empty($limits) )
  			$found_rows = 'SQL_CALC_FOUND_ROWS';
  
! 		$this->request = $old_request = "SELECT $found_rows $distinct $fields FROM $wpdb->posts $join WHERE 1=1 $where $groupby $orderby $limits";
! 
! 		if ( !$q['suppress_filters'] ) {
! 			$this->request = apply_filters_ref_array( 'posts_request', array( $this->request, &$this ) );
! 		}
  
  		if ( 'ids' == $q['fields'] ) {
  			$this->posts = $wpdb->get_col($this->request);
***************
*** 2629,2637 ****
  			return $r;
  		}
  
! 		$this->posts = $wpdb->get_results($this->request);
  
! 		// Raw results filter.  Prior to status checks.
  		if ( !$q['suppress_filters'] )
  			$this->posts = apply_filters_ref_array('posts_results', array( $this->posts, &$this ) );
  
--- 2627,2660 ----
  			return $r;
  		}
  
! 		$split_the_query = ( $old_request == $this->request && "$wpdb->posts.*" == $fields && !empty( $limits ) && $q['posts_per_page'] < 500 );
! 		$split_the_query = apply_filters( 'split_the_query', $split_the_query, $this );
! 
! 		if ( $split_the_query ) {
! 			// First get the IDs and then fill in the objects
  
! 			$this->request = "SELECT $found_rows $distinct $wpdb->posts.ID FROM $wpdb->posts $join WHERE 1=1 $where $groupby $orderby $limits";
! 
! 			$this->request = apply_filters( 'posts_request_ids', $this->request, $this );
! 
! 			$ids = $wpdb->get_col( $this->request );
! 
! 			if ( $ids ) {
! 				$this->set_found_posts( $q, $limits );
! 
! 				_prime_post_caches( $ids, $q['update_post_term_cache'], $q['update_post_meta_cache'] );
! 
! 				$this->posts = array_map( 'get_post', $ids );
! 			} else {
! 				$this->found_posts = $this->max_num_pages = 0;
! 				$this->posts = array();
! 			}
! 		} else {
! 			$this->posts = $wpdb->get_results( $this->request );
! 			$this->set_found_posts( $q, $limits );
! 		}
! 
! 		// Raw results filter. Prior to status checks.
  		if ( !$q['suppress_filters'] )
  			$this->posts = apply_filters_ref_array('posts_results', array( $this->posts, &$this ) );
  
***************
*** 2648,2660 ****
  			$this->comment_count = count($this->comments);
  		}
  
- 		if ( !$q['no_found_rows'] && !empty($limits) ) {
- 			$found_posts_query = apply_filters_ref_array( 'found_posts_query', array( 'SELECT FOUND_ROWS()', &$this ) );
- 			$this->found_posts = $wpdb->get_var( $found_posts_query );
- 			$this->found_posts = apply_filters_ref_array( 'found_posts', array( $this->found_posts, &$this ) );
- 			$this->max_num_pages = ceil($this->found_posts / $q['posts_per_page']);
- 		}
- 
  		// Check post status to determine if post should be displayed.
  		if ( !empty($this->posts) && ($this->is_single || $this->is_page) ) {
  			$status = get_post_status($this->posts[0]);
--- 2671,2676 ----
***************
*** 2683,2689 ****
  				}
  			}
  
! 			if ( $this->is_preview && current_user_can( $edit_cap, $this->posts[0]->ID ) )
  				$this->posts[0] = apply_filters_ref_array('the_preview', array( $this->posts[0], &$this ));
  		}
  
--- 2699,2705 ----
  				}
  			}
  
! 			if ( $this->is_preview && $this->posts && current_user_can( $edit_cap, $this->posts[0]->ID ) )
  				$this->posts[0] = apply_filters_ref_array('the_preview', array( $this->posts[0], &$this ));
  		}
  
***************
*** 2700,2706 ****
  					array_splice($this->posts, $i, 1);
  					// Move to front, after other stickies
  					array_splice($this->posts, $sticky_offset, 0, array($sticky_post));
! 					// Increment the sticky offset.  The next sticky will be placed at this offset.
  					$sticky_offset++;
  					// Remove post from sticky posts array
  					$offset = array_search($sticky_post->ID, $sticky_posts);
--- 2716,2722 ----
  					array_splice($this->posts, $i, 1);
  					// Move to front, after other stickies
  					array_splice($this->posts, $sticky_offset, 0, array($sticky_post));
! 					// Increment the sticky offset. The next sticky will be placed at this offset.
  					$sticky_offset++;
  					// Remove post from sticky posts array
  					$offset = array_search($sticky_post->ID, $sticky_posts);
***************
*** 2757,2762 ****
--- 2773,2790 ----
  		return $this->posts;
  	}
  
+ 	function set_found_posts( $q, $limits ) {
+ 		global $wpdb;
+ 
+ 		if ( $q['no_found_rows'] || empty( $limits ) )
+ 			return;
+ 
+ 		$this->found_posts = $wpdb->get_var( apply_filters_ref_array( 'found_posts_query', array( 'SELECT FOUND_ROWS()', &$this ) ) );
+ 		$this->found_posts = apply_filters_ref_array( 'found_posts', array( $this->found_posts, &$this ) );
+ 
+ 		$this->max_num_pages = ceil( $this->found_posts / $q['posts_per_page'] );
+ 	}
+ 
  	/**
  	 * Set up the next post and iterate current post index.
  	 *
***************
*** 2929,2935 ****
  		if ( isset($this->queried_object) )
  			return $this->queried_object;
  
! 		$this->queried_object = NULL;
  		$this->queried_object_id = 0;
  
  		if ( $this->is_category || $this->is_tag || $this->is_tax ) {
--- 2957,2963 ----
  		if ( isset($this->queried_object) )
  			return $this->queried_object;
  
! 		$this->queried_object = null;
  		$this->queried_object_id = 0;
  
  		if ( $this->is_category || $this->is_tag || $this->is_tax ) {
***************
*** 2953,2959 ****
  			$this->queried_object = get_post_type_object( $this->get('post_type') );
  		} elseif ( $this->is_posts_page ) {
  			$page_for_posts = get_option('page_for_posts');
! 			$this->queried_object = & get_page( $page_for_posts );
  			$this->queried_object_id = (int) $this->queried_object->ID;
  		} elseif ( $this->is_singular && !is_null($this->post) ) {
  			$this->queried_object = $this->post;
--- 2981,2987 ----
  			$this->queried_object = get_post_type_object( $this->get('post_type') );
  		} elseif ( $this->is_posts_page ) {
  			$page_for_posts = get_option('page_for_posts');
! 			$this->queried_object = get_page( $page_for_posts );
  			$this->queried_object_id = (int) $this->queried_object->ID;
  		} elseif ( $this->is_singular && !is_null($this->post) ) {
  			$this->queried_object = $this->post;
***************
*** 3593,3596 ****
  
  	return true;
  }
- ?>
--- 3620,3622 ----
